#!/bin/sh
# Last modified: 22/01/2009

SPARROW_CONF="/var/db/sparrow"
WWW_DIR="/usr/local/www"
SQUID_LOGS_DIR="/usr/local/squid/logs"
LOCAL_SBIN="/usr/local/sbin"
SQUID_SUDO="/usr/local/bin/sudo -u squid"
SQUID_OWNER="squid:squid"
CP="/bin/cp -i"

#    
/usr/local/bin/createuser -A -R -D -e -U pgsql sparrow
/usr/local/bin/createdb -e -E KOI8 -O sparrow -U pgsql sparrowdb
/usr/local/bin/createlang -e -U pgsql plpgsql sparrowdb
/usr/local/bin/psql -f ./sparrowdb.sql sparrowdb sparrow

#   
for i in ./authenticator.pl ./squidAgent.pl ./periodic.pl ./ext_acl.pl ./config_cli.pl ; 
do
	$CP $i $LOCAL_SBIN/$i ;
	/bin/chmod 0555 $LOCAL_SBIN/$i ;
done

#    
/bin/mkdir $SPARROW_CONF
/usr/sbin/chown $SQUID_OWNER $SPARROW_CONF
/bin/chmod 0770 $SPARROW_CONF

#      
$SQUID_SUDO ./config_cli.pl debug 0
$SQUID_SUDO ./config_cli.pl logfile $SQUID_LOGS_DIR/sparrow.log
$SQUID_SUDO ./config_cli.pl dbname sparrowdb
$SQUID_SUDO ./config_cli.pl dbhost localhost
$SQUID_SUDO ./config_cli.pl dbuser sparrow
$SQUID_SUDO ./config_cli.pl dbpassword secret
$SQUID_SUDO ./config_cli.pl squid_access_log $SQUID_LOGS_DIR/access.log
$SQUID_SUDO ./config_cli.pl squid_bin $LOCAL_SBIN/squid
$SQUID_SUDO ./config_cli.pl squid_log_agent_pidfile $SQUID_LOGS_DIR/log_agent.pid
$SQUID_SUDO ./config_cli.pl squid_log_agent_lastrun 1
$SQUID_SUDO ./config_cli.pl periodic_pidfile $SQUID_LOGS_DIR/periodic.pid
$SQUID_SUDO ./config_cli.pl count_cached_requests 0
$SQUID_SUDO ./config_cli.pl statis_timepoint 1
$SQUID_SUDO ./config_cli.pl tmpl_dir $WWW_DIR/sparrow-tmpl
$SQUID_SUDO ./config_cli.pl cur_period_start_timepoint 1
$SQUID_SUDO ./config_cli.pl null_passwords_allowed 0
$SQUID_SUDO ./config_cli.pl max_period_size 0
$SQUID_SUDO ./config_cli.pl def_user_access 0
$SQUID_SUDO ./config_cli.pl def_ip_access 0
$SQUID_SUDO ./config_cli.pl archive_basedir $WWW_DIR/sparrow-archive

/bin/echo "* * * * * squid /usr/local/sbin/squidAgent.pl >/usr/local/squid/logs/squidAgent.mesg 2>&1" >> /etc/crontab
/bin/echo "21 3 * * * squid /usr/local/sbin/periodic.pl >/usr/local/squid/logs/periodic.mesg 2>&1" >> /etc/crontab

#     
/bin/mkdir $WWW_DIR/sparrow-archive
/usr/sbin/chown $SQUID_OWNER $WWW_DIR/sparrow-archive
/bin/chmod 0770 $WWW_DIR/sparrow-archive

#    web-gui
$CP ./www/cgi/* $WWW_DIR/cgi-bin/
/bin/mkdir $WWW_DIR/sparrow-tmpl
$CP ./www/tmpl/* $WWW_DIR/sparrow-tmpl
/bin/mkdir $WWW_DIR/data/src
$CP ./www/src/* $WWW_DIR/data/src/
/bin/mkdir $WWW_DIR/data/img
$CP ./www/img/* $WWW_DIR/data/img/
$CP ./www/index.html $WWW_DIR/data/
$CP ./www/doc.html $WWW_DIR/data/
